#! /bin/bash

mode=${1:-commit-id}
res=0

mydir=$(dirname $BASH_SOURCE)
cd $mydir

case $mode in
    commit-id)
        git log -n 1 --oneline --abbrev=8 | cut -d ' ' -f 1
        res=${PIPESTATUS[0]}
        ;;
    svnversion)
        branch=${2:-master}
        numcommits=$(git rev-list $branch | wc -l)
        git log -n 1 --oneline &> /dev/null
        res=$?
        if [[ "$res" = "0" ]]; then
            baserev=5114
            echo $((numcommits + baserev))
        fi
        ;;
    vc-version-file)
        COMMIT_ID=${2:-$(./gen-vc-version-file.sh commit-id)}
        res=$?
        if [[ "$res" != "0" ]]; then exit $res; fi
        SVN_REVISION=${3:-$(./gen-vc-version-file.sh svnversion)}
        res=$?
        if [[ "$res" != "0" ]]; then exit $res; fi
        echo "SVN_REVISION=$SVN_REVISION"
        echo "COMMIT_ID=$COMMIT_ID"
        ;;
esac

exit $res
